import * as mc from "@minecraft/server"
import { ActionFormData } from "@minecraft/server-ui"

mc.world.afterEvents.itemUse.subscribe(event => {
	let item = event.itemStack

	if (item.typeId == "willy:gui") {
		let gui = new ActionFormData()
		gui.title("Voices_list")
		gui.button("British_voice")
		gui.button("German_voice")
		gui.button("French_voice")
		gui.button("American_voice")
		gui.button("Russian_voice")
      gui.button("No_voice_lines")
		gui.button("Japanese_voice")
		gui.button("British_voice_2")
		gui.button("German_voice_2")
		gui.button("French_voice_2")
		gui.button("American_voice_2")
		gui.button("Polish_voice")
		gui.button("Scottish_voice")
		gui.button("American_voice_3")
		gui.button("German_voice_3")
		gui.button("Australian_voice")
		gui.button("American_voice_4")
		gui.button("Canadian_voice")
		gui.button("Indian_english_voice")
		gui.button("Japanese_voice_2")
		gui.button("Japanese_voice_1")

		gui.show(event.source).then(result => {
			if (result.canceled) {
				return
			}

			if (result.selection == 0) {
				event.source.runCommand("scoreboard players set @s voice 1")
			}

			if (result.selection == 1) {
				event.source.runCommand("scoreboard players set @s voice 2")
			}

			if (result.selection == 2) {
				event.source.runCommand("scoreboard players set @s voice 3")
			}

			if (result.selection == 3) {
				event.source.runCommand("scoreboard players set @s voice 4")
			}

			if (result.selection == 4) {
				event.source.runCommand("scoreboard players set @s voice 5")
			}
			if (result.selection == 5) {
				event.source.runCommand("scoreboard players set @s voice 0")
			}
			if (result.selection == 6) {
				event.source.runCommand("scoreboard players set @s voice 6")
			}
			if (result.selection == 7) {
				event.source.runCommand("scoreboard players set @s voice 7")
			}
			if (result.selection == 8) {
				event.source.runCommand("scoreboard players set @s voice 8")
			}
			if (result.selection == 9) {
				event.source.runCommand("scoreboard players set @s voice 9")
			}
			if (result.selection == 10) {
				event.source.runCommand("scoreboard players set @s voice 10")
			}
			if (result.selection == 11) {
				event.source.runCommand("scoreboard players set @s voice 11")
			}
			if (result.selection == 12) {
				event.source.runCommand("scoreboard players set @s voice 12")
			}
			if (result.selection == 13) {
				event.source.runCommand("scoreboard players set @s voice 13")
			}
			if (result.selection == 14) {
				event.source.runCommand("scoreboard players set @s voice 14")
			}
			if (result.selection == 15) {
				event.source.runCommand("scoreboard players set @s voice 15")
			}
			if (result.selection == 16) {
				event.source.runCommand("scoreboard players set @s voice 16")
			}
			if (result.selection == 17) {
				event.source.runCommand("scoreboard players set @s voice 17")
			}
			if (result.selection == 18) {
				event.source.runCommand("scoreboard players set @s voice 18")
			}
			if (result.selection == 19) {
				event.source.runCommand("scoreboard players set @s voice 19")
			}
			if (result.selection == 20) {
				event.source.runCommand("scoreboard players set @s voice 20")
			}
		})
	}
})
import {
	world, system, EntityComponentTypes
} from "@minecraft/server"

world.afterEvents.entityHurt.subscribe(event => {
	let player = event.hurtEntity
	let damage = event.damage

	if (player.typeId == "minecraft:player") {
		player.runCommandAsync(`title @s title hud@blood`)
		player.runCommandAsync(`function hurtvoice`)
	}
})
system.runInterval(() => {
	
	world.getAllPlayers().forEach(player => {
		let component = player.getComponent(EntityComponentTypes.Health)
		
		if (component) {
			let hp = component.currentValue
			
			
			
			if (hp < 5) {
				player.runCommand("title @s title hud@blood")
				player.runCommand("effect @s slowness 2 0 true")
			}
		}
	})
}, 30)
function directionPlayerMoving(data){
	let velocityX = data.target.getVelocity().x;
	let velocityZ = data.target.getVelocity().z;
	mc.system.runTimeout(() => {
		mc.world.setDynamicProperty('savedVelocityX', velocityX);
		mc.world.setDynamicProperty('savedVelocityZ', velocityZ);
		mc.system.runTimeout(() => {
			mc.world.setDynamicProperty('savedVelocityX1', velocityX);
			mc.world.setDynamicProperty('savedVelocityZ1', velocityZ);
			mc.system.runTimeout(() => {
				mc.world.setDynamicProperty('savedVelocityX2', velocityX);
				mc.world.setDynamicProperty('savedVelocityZ2', velocityZ);
			},1);
		},1);
	},1);
	let hS = ((velocityX + mc.world.getDynamicProperty('savedVelocityX') + mc.world.getDynamicProperty('savedVelocityX1') + mc.world.getDynamicProperty('savedVelocityX2')) + (velocityZ + mc.world.getDynamicProperty('savedVelocityZ') + mc.world.getDynamicProperty('savedVelocityZ1') + mc.world.getDynamicProperty('savedVelocityZ2'))) * 1.03915519041 * 1.14673976685;
	let hDx = (velocityX + mc.world.getDynamicProperty('savedVelocityX') + mc.world.getDynamicProperty('savedVelocityX1') + mc.world.getDynamicProperty('savedVelocityX2')) * 1.03915519041 * 1.14673976685;
	let hDz = (velocityZ + mc.world.getDynamicProperty('savedVelocityZ') + mc.world.getDynamicProperty('savedVelocityZ1') + mc.world.getDynamicProperty('savedVelocityZ2')) * 1.03915519041 * 1.14673976685;
	if(velocityX !== 0 && velocityZ !== 0){
		data.player.applyKnockback(velocityX, 0, Math.abs(hDx * 2), 0);
		data.player.applyKnockback(0 ,velocityZ, Math.abs(hDz), 0);
	}
	else{
		data.player.applyKnockback(velocityX, velocityZ, Math.abs(hS), 0);
	}
}

mc.world.afterEvents.playerInteractWithEntity.subscribe((data) => {
	if(data.itemStack.typeId === 'minecraft:stick'){
		mc.system.runInterval(() => {
			return directionPlayerMoving(data);
		},4);
	}
});
mc.world.afterEvents.itemUse.subscribe((data) => {
	if(data.itemStack.typeId === 'minecraft:wooden_pickaxe'){
		mc.world.clearDynamicProperties();
	}
});